<template>
  <div class="dialog-table-container">
    <el-table :element-loading-background="loadingColor" v-loading="loading" height="65vh" align="center"
      :data="tableData" class="dialog_table" :cell-style="{ 'text-align': 'center' }"
      :header-cell-style="{ 'text-align': 'center' }" ref="myTable">
      <!-- <el-table-column type="expand" label="点击查看详情" width="140">
                <template slot-scope="props">
                    <el-form label-position="top" class="dialog-table-expand">
                        <el-row>
                            <el-form-item label="解决问题：">
                                <span>{{ props.row.solveProblem }}</span>
                            </el-form-item>
                        </el-row>
                        <el-row>
                            <el-form-item label="运转实效：">
                                <span>{{ props.row.actualEffect }}</span>
                            </el-form-item>
                        </el-row>
                        <el-row>
                            <el-form-item label="佐证材料：">
                                <el-row v-if="props.row.fileList">
                                    <el-col
                                        :span="8"
                                        v-for="(file, index) in props.row
                                            .fileList"
                                        :key="index"
                                    >
                                        <div class="file-style">
                                            <div class="file-item">
                                                <span
                                                    class="file-name"
                                                    :title="
                                                        file.name
                                                            ? file.name
                                                            : file.fileName +
                                                              '.' +
                                                              file.extensionName
                                                    "
                                                    >{{
                                                        file.name
                                                            ? file.name
                                                            : file.fileName +
                                                              '.' +
                                                              file.extensionName
                                                    }}</span
                                                >
                                                <span class="file-btn short">
                                                    <el-link
                                                        type="primary"
                                                        :underline="false"
                                                        @click="
                                                            handlePreview(file)
                                                        "
                                                        style="color: #fff"
                                                        >预览</el-link
                                                    >
                                                    <el-link
                                                        type="primary"
                                                        :underline="false"
                                                        style="color: #fff"
                                                        @click="
                                                            handleDownloadFile(
                                                                file
                                                            )
                                                        "
                                                        >下载</el-link
                                                    >
                                                </span>
                                            </div>
                                        </div>
                                    </el-col>
                                </el-row>
                            </el-form-item>
                        </el-row>
                    </el-form>
                </template>
            </el-table-column> -->
      <el-table-column type="index" label="序号" width="50"> </el-table-column>
      <el-table-column prop="completedWork" label="制度名称" min-width="200">
      </el-table-column>
      <el-table-column prop="projectName" label="项目名称"> </el-table-column>
      <el-table-column prop="createTime" label="搭建日期" width="80">
      </el-table-column>
      <el-table-column type="expand" label="" width="0">
        <template>
          <div class="myInfo" v-loading="reqLoading" element-loading-text="加载中..."
            element-loading-spinner="el-icon-loading" element-loading-background="rgba(2, 62, 139, 1)">
            <el-descriptions :column="3" border :labelStyle="{ width: '1%', opacity: isShow }"
              :contentStyle="{ opacity: isShow }">
              <el-descriptions-item :span="3" label="解决问题：">
                {{ infoData.problems }}
              </el-descriptions-item>
              <el-descriptions-item :span="3" label="运行实效：">
                {{ infoData.workPlan }}
              </el-descriptions-item>
              <el-descriptions-item :span="3" label="运行实效：">
                <template>
                  <div class="file-style" v-if="infoData.defaultFileList">
                    <div class="file-item" v-for="(file, index) in infoData.defaultFileList" :key="index">
                      <span class="file-name" :title="file.name
                          ? file.name
                          : file.fileName + '.' + file.extensionName
                        ">{{
    file.name
    ? file.name
    : file.fileName + '.' + file.extensionName
  }}</span>
                      <span class="file-btn short">
                        <el-link type="primary" :underline="false" @click="handlePreview(file)"
                          style="color: #fff">预览</el-link>
                        <el-link type="primary" :underline="false" style="color: #fff"
                          @click="handleDownloadFile(file)">下载</el-link>
                      </span>
                    </div>
                  </div>
                  <el-row v-else>{{ infoData.classified }}</el-row>
                </template>
              </el-descriptions-item>
            </el-descriptions>
          </div>
        </template>
      </el-table-column>
      <el-table-column label="详情" width="90">
        <template v-slot="{ row }">
          <el-tag effect="dark" style="cursor: pointer" @click="handleDetail(row)">查看详情
          </el-tag>
        </template>
      </el-table-column>
    </el-table>
    <pagenation :pageResult="pageBean" @currentChange="pageChange" class="pagenation"></pagenation>
    <filePreview ref="filePreview" :appendToBody="true"></filePreview>
  </div>
</template>

<script>
import filePreview from '@/components/FilePreview/filePreview.vue'
import apiList from '@/api/bigScreen/majorView.js'
const portal = window.context.portal
import pagenation from './pagenation.vue'
import moment from 'moment'
export default {
  components: { pagenation, filePreview },
  name: 'institutionalAchievements',
  props: {
    tableOptions: {
      type: Object,
      default: () => {
        return {}
      }
    }
  },
  data() {
    return {
      reqLoading: false,
      previewUrl: `${portal}/file/onlinePreviewController/v1/getFileById_`,
      loading: false,
      loadingColor: 'rgba(6, 46, 106, 0.4)',
      tableData: [],
      // tableData: [
      //     {
      //         id: 1,
      //         objectName: '平台名称',
      //         projectName: '推动数字重庆建设',
      //         finishTime: '2023-01-01',
      //         area: '璧山',
      //         fujian: '',
      //         shixiao:
      //             '本平台运行后为**************************************。',
      //         resolve:
      //             '为解决XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX。',
      //     },
      //     {
      //         id: 2,
      //         objectName: '平台名称',
      //         projectName: '全市开发区（园区）数',
      //         finishTime: '2023-01-01',
      //         area: '璧山',
      //         fujian: '',
      //         shixiao:
      //             '本平台运行后为**************************************。',
      //         resolve:
      //             '为解决XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX。',
      //     },
      //     {
      //         id: 3,
      //         objectName: '平台名称',
      //         projectName: '探索制造业“亩均论英雄”改革',
      //         finishTime: '2023-01-01',
      //         area: '璧山',
      //         fujian: '',
      //         shixiao:
      //             '本平台运行后为**************************************。',
      //         resolve:
      //             '为解决XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX。',
      //     },
      //     {
      //         id: 4,
      //         objectName: '平台名称',
      //         projectName: '实施国企战略性重组和专业化整合',
      //         finishTime: '2023-01-01',
      //         area: '璧山',
      //         fujian: '',
      //         shixiao:
      //             '本平台运行后为**************************************。',
      //         resolve:
      //             '为解决XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX。',
      //     },
      //     {
      //         id: 5,
      //         objectName: '平台名称',
      //         projectName: '建立企业上市助推机制',
      //         finishTime: '2023-01-01',
      //         area: '璧山',
      //         fujian: '',
      //         shixiao:
      //             '本平台运行后为**************************************。',
      //         resolve:
      //             '为解决XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX。',
      //     },
      //     {
      //         id: 6,
      //         objectName: '平台名称',
      //         projectName: '探索强村富民综合改革',
      //         finishTime: '2023-01-01',
      //         area: '璧山',
      //         fujian: '',
      //         shixiao:
      //             '本平台运行后为**************************************。',
      //         resolve:
      //             '为解决XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX。',
      //     },
      //     {
      //         id: 7,
      //         objectName: '平台名称',
      //         projectName: '探索经济区与行政区适度分离改革',
      //         finishTime: '2023-01-01',
      //         area: '璧山',
      //         fujian: '',
      //         shixiao:
      //             '本平台运行后为**************************************。',
      //         resolve:
      //             '为解决XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX。',
      //     },
      //     {
      //         id: 8,
      //         objectName: '平台名称',
      //         projectName: '推进涉企涉民服务全生命周期“一件事一次办”',
      //         finishTime: '2023-01-01',
      //         area: '璧山',
      //         fujian: '',
      //         shixiao:
      //             '本平台运行后为**************************************。',
      //         resolve:
      //             '为解决XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX。',
      //     },
      //     {
      //         id: 9,
      //         objectName: '平台名称',
      //         projectName: '打造“信用重庆”升级版',
      //         finishTime: '2023-01-01',
      //         area: '璧山',
      //         fujian: '',
      //         shixiao:
      //             '本平台运行后为**************************************。',
      //         resolve:
      //             '为解决XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX。',
      //     },
      //     {
      //         id: 10,
      //         objectName: '平台名称',
      //         projectName: '建设政企学研深度融合的现代职教体系',
      //         finishTime: '2023-01-01',
      //         area: '璧山',
      //         fujian: '',
      //         shixiao:
      //             '本平台运行后为**************************************。',
      //         resolve:
      //             '为解决XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX。',
      //     },
      //     {
      //         id: 11,
      //         objectName: '平台名称',
      //         projectName: '健全平安重庆风险闭环管控机制',
      //         finishTime: '2023-01-01',
      //         area: '璧山',
      //         fujian: '',
      //         shixiao:
      //             '本平台运行后为**************************************。',
      //         resolve:
      //             '为解决XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX。',
      //     },
      //     {
      //         id: 10,
      //         objectName: '平台名称',
      //         projectName: '推进渝警数智“情指行”一体化现代警务改革',
      //         finishTime: '2023-01-01',
      //         area: '璧山',
      //         fujian: '',
      //         shixiao:
      //             '本平台运行后为**************************************。',
      //         resolve:
      //             '为解决XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX。',
      //     },
      //     {
      //         id: 10,
      //         objectName: '平台名称',
      //         projectName: '建立领导班子运行评估和群众口碑评价机制',
      //         finishTime: '2023-01-01',
      //         area: '璧山',
      //         fujian: '',
      //         shixiao:
      //             '本平台运行后为**************************************。',
      //         resolve:
      //             '为解决XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX。',
      //     },
      //     {
      //         id: 10,
      //         objectName: '平台名称',
      //         projectName: '推进“党建扎桩·治理结网”基层治理现代化改革',
      //         finishTime: '2023-01-01',
      //         area: '璧山',
      //         fujian: '',
      //         shixiao:
      //             '本平台运行后为**************************************。',
      //         resolve:
      //             '为解决XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX。',
      //     },
      //     {
      //         id: 15,
      //         objectName: '平台名称',
      //         projectName: '实施投融资多元化改革',
      //         finishTime: '2023-01-01',
      //         area: '璧山',
      //         fujian: '',
      //         shixiao:
      //             '本平台运行后为**************************************。',
      //         resolve:
      //             '为解决XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX。',
      //     },
      // ],
      params: {
        pageBean: {
          page: 1,
          pageSize: 10,
          total: 0,
          showTotal: true
        },
        params: {},
        querys: [
          {
            group: 'main',
            operation: 'EQUAL',
            parentGroup: '',
            property: 'type',
            relation: 'AND',
            value: 3
          }
        ]
      },
      pageBean: {
        page: 1,
        pageSize: 10,
        total: 0,
        showTotal: true
      },
      paramsFile: {
        pageBean: {
          page: 1,
          pageSize: -1,
          showTotal: true
        },
        querys: [
          {
            group: 'main',
            operation: 'EQUAL',
            parentGroup: '',
            property: 'BIZ_ID_',
            relation: 'AND',
            value: ''
          }
        ]
      },
      infoData: {},
      isShow: 1
    }
  },
  mounted() {
    this.getResultList()
  },
  methods: {
    getResultList() {
      this.loading = true
      let searchDate = JSON.parse(sessionStorage.getItem('searchDate'))
      let data = {
        querys: [
          {
            group: 'main',
            operation: 'EQUAL',
            parentGroup: '',
            property: 's.PLAN_YEAR_', // 字段名
            relation: 'AND',
            value: searchDate.year
          },
          {
            group: 'main',
            operation: 'LESS_EQUAL',
            parentGroup: '',
            property: 's.PLAN_MONTH_', // 字段名
            relation: 'AND',
            value: searchDate.month
          },
          {
            group: 'main',
            operation: 'EQUAL',
            parentGroup: '',
            property: 's.PLAN_type_',
            relation: 'AND',
            value: 5
          }
        ]
      }
      data.pageBean = this.pageBean
      apiList.getResultList(data, res => {
        if (res) {
          this.tableData = res.rows.map(item => {
            item.createTime = moment(item.createTime).format('YYYY-MM-DD')
            return item
          })
          this.pageBean.total = res.total
        }
        this.loading = false
      })
    },
    handleDetail(row) {
      this.reqLoading = true
      this.isShow = 0
      if (!row.expansion) {
        apiList.getResultD(row.id, res => {
          if (res) {
            this.infoData = res,
              this.isShow = 1
            this.reqLoading = false
          }
        })
      }
      this.$nextTick(() => {
        let $table = this.$refs.myTable
        this.tableData.map(item => {
          if (row.id != item.id) {
            $table.toggleRowExpansion(item, false)
            item.expansion = false
          } else {
            item.expansion = !item.expansion
          }
        })
        $table.toggleRowExpansion(row)
      })
    },
    pageChange(key) {
      this.pageBean.page = key
      this.getResultList()
    },
    expandChange(row, expandedRows) {
      console.log(row, expandedRows)
      if (row.fileList) return
      this.getFiles(row)
    },
    getFiles(row) {
      this.paramsFile.querys[0].value = row.id
      apiList.getFiles(this.paramsFile, data => {
        row.fileList = data.rows
      })
      let index = this.tableData.findIndex(item => item.id == row.id)
      this.tableData.splice(index, 1, row)
    },
    handlePreview(file) {
      let id = file.fileId
        ? file.fileId
        : file.id
          ? file.id
          : file.response.fileId
      let type = file.fileType || (file.extensionName
        ? file.extensionName
        : file.name.split('.')[1])
      this.$refs.filePreview.previewUrl = this.previewUrl + id
      this.$refs.filePreview.open(type)
    },
    // 文件下载
    handleDownloadFile(file) {
      console.log(file)
      let id = file.fileId
        ? file.fileId
        : file.id
          ? file.id
          : file.response.fileId
      window.open(portal + `/file/v1/downloadFile?fileId=${id}`, '_self')
    }
  }
}
</script>
<style lang="scss" scoped>
.myInfo {
  /deep/.el-descriptions__body {
    // background: transparent;
    background: rgba(2, 62, 141, 1);
    box-sizing: border-box;

    .el-descriptions__table {
      // background: transparent;
      background: rgba(2, 62, 141, 1);

      th,
      tr,
      td {
        background: rgba(2, 62, 141, 1);
        color: #f3f3f3;
      }
    }
  }

  /deep/.el-descriptions .is-bordered .el-descriptions-item__cell {
    // border: 1px #01215a solid;
    // border-left: none;
    border: none;
  }
}

/deep/.el-table__expand-column .cell {
  width: 0;
  height: 0;
  display: none;
}

.file-item {
  display: flex;
  justify-content: space-between;
  width: 100%;
  padding: 5px 0 5px 8px;
  margin-left: -5px;

  //   border-bottom: 1px solid #f5f5f5;
  >* {
    font-size: 14px !important;
  }

  a {
    margin: 0 10px;
    user-select: none;
  }

  .file_name {
    max-width: 220px;
    height: 22px;
    overflow: hidden;
    white-space: nowrap;
    text-overflow: ellipsis;
  }
}
</style>
<style lang="scss">
@import './table.scss';
</style>
